--
-- silageAdditive-Script
-- 
-- Author: Dominik Raith (DR_Modding)
--
--
------------------------------------------------------------------------------------------------------
-- add new Specialization: trailerAlmostFullSound

trailerAlmostFullSound = {};
trailerAlmostFullSound.modDir = g_currentModDirectory;
trailerAlmostFullSound.MOD_NAME = g_currentModName;




-- Checks if all prerequisite specializations are loaded
function trailerAlmostFullSound.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(FillUnit, specializations) and SpecializationUtil.hasSpecialization(Dischargeable, specializations);
end;

function trailerAlmostFullSound.registerEventListeners(vehicleType)
    SpecializationUtil.registerEventListener(vehicleType, "onLoad", trailerAlmostFullSound)
    SpecializationUtil.registerEventListener(vehicleType, "onUpdate", trailerAlmostFullSound)
    SpecializationUtil.registerEventListener(vehicleType, "onUpdateTick", trailerAlmostFullSound)
    SpecializationUtil.registerEventListener(vehicleType, "onFillUnitFillLevelChanged", trailerAlmostFullSound)
end


 --on load: seams to be a standard procedure
function trailerAlmostFullSound:onLoad(savegame)
	self.spec_trailerAlmostFullSound = self[string.format("spec_%s.trailerAlmostFullSound", trailerAlmostFullSound.MOD_NAME)]
	baseKey = "vehicle"
	
	trailerAlmostFullSound.fillLevelWarningsTextXML = Utils.getNoNil(getXMLBool(self.xmlFile, baseKey .. ".trailerAlmostFullSound#fillLevelWarningsText"), true)
	trailerAlmostFullSound.fillLevelWarningsSoundXML = Utils.getNoNil(getXMLBool(self.xmlFile, baseKey .. ".trailerAlmostFullSound#fillLevelWarningsSound"), true)
	trailerAlmostFullSound.fillUnitIndex = Utils.getNoNil(getXMLInt(self.xmlFile, baseKey.. ".trailerAlmostFullSound#fillUnitIndex"), 1)
	trailerAlmostFullSound.volume = Utils.getNoNil(getXMLFloat(self.xmlFile, baseKey.. ".trailerAlmostFullSound#volume"), 1)
	self.showAlmostFullWarning = false
	self.playAlmostFullWarningSound = false
	self.showAlmostFullWarningAtStart = false
	self.playAlmostFullWarningSoundAtStart = false
    self.fillLevelChanged = false
	trailerAlmostFullSound.delayTime = 100;
end;


-- set a timer because the you hear and see the warning when starting the game
function trailerAlmostFullSound:onUpdateTick(dt)

    if trailerAlmostFullSound.delayTime > 0 then
        trailerAlmostFullSound.delayTime = trailerAlmostFullSound.delayTime - 1;
    else
		self.showAlmostFullWarningAtStart = true
		self.playAlmostFullWarningSoundAtStart = true
    end;
	
	
end;



-- onFillUnitFillLevelChanged: usage of fillUnits
function trailerAlmostFullSound:onFillUnitFillLevelChanged(fillUnitIndex, fillLevelDelta, fillTypeIndex, toolType, fillPositionData, appliedDelta)
    local spec = self.spec_trailerAlmostFullSound;	
	
	local fillUnitIndex1 = trailerAlmostFullSound.fillUnitIndex;
	
	if fillUnitIndex == fillUnitIndex1 then
		
		local fillLevel = self:getFillUnitFillLevel(fillUnitIndex1);
			
		if fillLevel > 0 and fillLevelDelta > 0 then			
				self.fillLevelChanged = true
		end;

    end;
    	
end;


-- load BeepSound
BeepSound = createSample("BeepSound")
local file = g_currentModDirectory.."sound/beepSound.mp3"
loadSample(BeepSound, file, false)


---Returns almost empty warning text and a warning sound 
function trailerAlmostFullSound:onUpdate(dt)
    local spec = self.spec_trailerAlmostFullSound
	local spec_fillUnit = self.spec_fillUnit

	local fillUnitIndex1 = trailerAlmostFullSound.fillUnitIndex;
	local isDischarging = self:getDischargeState()
	
	if self.isClient then
		if spec.isActive then
			local fillLevel = self:getFillUnitFillLevelPercentage(fillUnitIndex1);
			if fillLevel > 0.9 and fillLevel < 0.95 then
				if isDischarging <= 0 then
					if self.fillLevelChanged == true then
						local spec_attachable = self.spec_attachable
						if spec_attachable.attacherVehicle ~= nil then
							if trailerAlmostFullSound.fillLevelWarningsSoundXML == true then
								if self.playAlmostFullWarningSound == true then 
									if self.playAlmostFullWarningSoundAtStart == true then 
										
										playSample(BeepSound ,1 ,trailerAlmostFullSound.volume ,1 ,0 ,0)	-- (sampleName, howOftenPlay, Volume, ?, ?)
										self.playAlmostFullWarningSound = false
									end
								end
							end
							if trailerAlmostFullSound.fillLevelWarningsTextXML == true then
								if self.showAlmostFullWarningAtStart == true then
									if self.showAlmostFullWarning == true then 
										
										g_currentMission:showBlinkingWarning(g_i18n:getText("warning_trailerAlmostFull"), 5000)
										self.showAlmostFullWarning = false
									end
								end
							end
						end
					end
				end
			else
				if fillLevel < 0.9 then
				self.playAlmostFullWarningSound = true
				self.showAlmostFullWarning = true
				end 
			end
		end
	end
end

